#include "DxLib.h"

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int PixelShaderHandle ;
	int VertexShaderHandle ;
	float RotateAngle ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
	{
		// G[璼ɏI
		return -1 ;
	}

	// vO}uVF[_[fQDOgpłȂꍇ̓G[\ďI
	if( GetValidShaderVersion() < 200 )
	{
		// G[\
		DrawString( 0, 0, "vO}uVF[_[QDOgpłȂ̂悤ł", GetColor( 255,255,255 ) ) ;

		// L[͑҂
		WaitKey() ;
		
		// cwCǔn
		DxLib_End() ;

		// \tgI
		return 0 ;
	}

	// _VF[_[ǂݍ
	VertexShaderHandle = LoadVertexShader( "NormalMesh_DirLightVS.vso" ) ;

	// sNZVF[_[ǂݍ
	PixelShaderHandle = LoadPixelShader( "NormalMesh_DirLightPS.pso" ) ;

	// ̃bVfǂݍ
	ModelHandle = MV1LoadModel( "NormalBox.mqo" ) ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// f]l
	RotateAngle = 0.0f ;

	// f̕`ɃIWiVF[_[gpݒnmɂ
	MV1SetUseOrigShader( TRUE ) ;

	// gp钸_VF[_[Zbg
	SetUseVertexShader( VertexShaderHandle ) ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShaderHandle ) ;

	// fʂ̒SɃZbg
	MV1SetPosition( ModelHandle, VGet( 320.0f, 240.0f, 0.0f ) ) ;

	// ESCL[܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂ
		ClearDrawScreen() ;

		// f]lZ
		RotateAngle += 0.02f ;

		// f̉]lfɃZbg
		MV1SetRotationXYZ( ModelHandle, VGet( 0.0f, RotateAngle, 0.0f ) ) ;

		// f`
		MV1DrawModel( ModelHandle ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// ǂݍ񂾒_VF[_[̍폜
	DeleteShader( VertexShaderHandle ) ;

	// ǂݍ񂾃sNZVF[_[̍폜
	DeleteShader( PixelShaderHandle ) ;

	// ǂݍ񂾃f̍폜
	MV1DeleteModel( ModelHandle ) ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
